#pragma once
#include <d3dx9.h>

#pragma comment(lib, "d3dx9.lib")

struct TextureData
{
	UINT			width;		// eNX`[̕
	UINT			height;		// eNX`[̍
	UINT			srcWidth;	// 摜̕
	UINT			srcHeight;	// 摜̍
	IDirect3DTexture9*	pTexture;	// eNX`[̃|C^
};

void BlockRender(float x1, float y1, float x2, float y2);
bool LoadTexture(const WCHAR* pFileName, TextureData* pOut);
void DrowTexture(float x1, float x2, float y1, float y2, TextureData g_texData);
void DrowTexture(float x0, float y0, float x1, float y1, float x2, float y2, float x3, float y3, TextureData g_texData);

void release();
void CleanupResource(TextureData g_texData);
void Render();