#include "Enemy.h"
#include "Drawing.h"
#include "global.h"
#include "Enemy_MoveMent.h"
#include "UI.h"



TextureData Enemy;
TextureData Life_Bar_A;
TextureData Life_Bar_B;

float life_bar_A;
float life_bar_B;

struct ENEMY {
	float x, y;
	float life_A;
	float life_B;
	int state;
	int isLive;
	int zanki;
};

ENEMY enemy;

//摜
void Enemy_Initialize_Texture(){
	LoadTexture(TEXT("assets/Enemy_AKANE.png"), &Enemy);
	LoadTexture(TEXT("assets/Life_Bar_A.png"), &Life_Bar_A);
	LoadTexture(TEXT("assets/Life_Bar_B.png"), &Life_Bar_B);
}

//
void Enemy_Initialize()
{
	enemy.x = ENEMY_STATE_POSITION_X;
	enemy.y = ENEMY_STATE_POSITION_Y;
	enemy.life_A = ENEMY_LIFE_A;
	enemy.life_B = ENEMY_LIFE_B;
	enemy.state = 0;
	enemy.isLive = false;
	enemy.zanki = ENEMY_ZANKI;
}

//HP
void Enemy_HP_Initialize(){
	switch (enemy.state) {
	case 1:enemy.life_A = ENEMY_LIFE_A; enemy.life_B = ENEMY_LIFE_B; break;
	case 3:enemy.life_B = ENEMY_LIFE_B; break;
	}
}

//G̃Xe[^X
void Enemy_Life_Syori() {
	switch (enemy.zanki) {
		case 0:/*ɂQ[NA*/break;
		case 1:enemy.state = 3; Enemy_HP_Initialize(); break;
		case 2:enemy.state = 1; Enemy_HP_Initialize(); break;
		case 3:enemy.state = 1; Enemy_HP_Initialize(); break;
		case 4:enemy.state = 1; Enemy_HP_Initialize(); break;
	}
	if(enemy.state ==3) Cut_In();
	enemy.isLive = true;
}
//XV
void Enemy_Update()
{
	//SɎc@cĂXe[^XĒ`
	if (enemy.isLive == false) {
		Enemy_Life_Syori();
	}
	//̍UŐ錾
	switch (enemy.zanki) {
	case 0:/*ɂQ[NA*/ Game_State = GAME_END; break;
	case 1: if (enemy.state == 1); else Enemy___1(enemy.x, enemy.y); break;
	case 2: if (enemy.state == 1)Enemy___2_A(enemy.x, enemy.y); else Enemy___2_B(enemy.x, enemy.y); break;
	case 3: if (enemy.state == 1)Enemy___3_A(enemy.x, enemy.y); else Enemy___3_B(enemy.x, enemy.y); break;
	case 4: if (enemy.state == 1)Enemy___4_A(enemy.x, enemy.y); else Enemy___4_B(enemy.x, enemy.y); break;
	}
	//HPꂽ玟̍UɈړ
	if (enemy.state == 1 && enemy.life_A <= 0) {
		enemy.state = 2;
		Cut_In();
	}
	//HP0ɂȂ炢񎀖S
	if (enemy.life_B <= 0) {
		enemy.zanki--;
		enemy.isLive = false;
	}

	if (key_push&KEYIN_DEBUG_PAUSE) {
		if (enemy.state == 1) {
			enemy.life_A = 0;
		} else {
			enemy.life_B = 0;
		}
	}
	life_bar_A = enemy.life_A / ENEMY_LIFE_A;
	life_bar_B = enemy.life_B / ENEMY_LIFE_B;
}

//`揈
void Enemy_Render()
{
	DrowTexture(
		enemy.x - ENEMY_TEXTURE_SIZE,//x1
		enemy.y - ENEMY_TEXTURE_SIZE,//y1
		enemy.x + ENEMY_TEXTURE_SIZE,//x2 
		enemy.y + ENEMY_TEXTURE_SIZE,//y2 
		Enemy);
	if(enemy.state == 1) {
	DrowTexture(
		180,//x1
		30,//y1
		life_bar_A * 350+180,//x2 
		40,//y2 
		Life_Bar_A);
	DrowTexture(
		30,//x1
		30,//y1
		life_bar_B * 150+30,//x2 
		40,//y2 
		Life_Bar_B);
	}
	if (enemy.state == 2) {
		DrowTexture(
			30,//x1
			30,//y1
			life_bar_B * 150 +30,//x2 
			40,//y2 
			Life_Bar_B);
	}
	if (enemy.state == 3) {
		DrowTexture(
			30,//x1
			30,//y1
			life_bar_B * 500+30,//x2 
			40,//y2 
			Life_Bar_B);
	}
}

//J
void Enemy_Open()
{
	CleanupResource(Enemy); 
	CleanupResource(Life_Bar_A);
	CleanupResource(Life_Bar_B);
}

//bool Enemy_Hit_Decision(float x, float y) {
//	float xv = enemy.x - x;
//	float yv_A = (enemy.y+35) - y;
//	float yv_B = (enemy.y-20) - y;
//	float dist_A = sqrtf(xv * xv + yv_A * yv_A);
//	float dist_B = sqrtf(xv * xv + yv_B * yv_B);
//	if (dist_A < 46.0f) {
//		if (enemy.isLive == false) {
//			return false;
//		}
//		if (enemy.state == 1) {
//			enemy.life_A--;
//		} else {
//			enemy.life_B--;
//		}
//		return true;
//	}else if (dist_B < 46.0f) {
//		if (enemy.state == 1) {
//			enemy.life_A--;
//		}
//		else {
//			enemy.life_B--;
//		}
//		return true;
//	}else {
//		return false;
//	}
//
//}

//̒eƂ̓蔻
bool Enemy_Hit_Decision(float x, float y) {
	float xv = enemy.x - x;
	float yv_A = (enemy.y + 35) - y;
	float yv_B = (enemy.y - 20) - y;
	float dist_A = sqrtf(xv * xv + yv_A * yv_A);
	float dist_B = sqrtf(xv * xv + yv_B * yv_B);
	if (enemy.isLive == true) {
		if (dist_A < 46.0f) {
			if (enemy.state == 1) {
				enemy.life_A--;
			}
			else {
				enemy.life_B--;
			}
			return true;
		}
		else if (dist_B < 46.0f) {
			if (enemy.state == 1) {
				enemy.life_A--;
			}
			else {
				enemy.life_B--;
			}
			return true;
		}
	}
	return false;
}
