#include "EnemyBullet.h"
#include "DirectX.h"
#include "Drawing.h"
#include <d3dx9.h>
#include "Enemy.h"
#include "player.h"
#include "global.h"
#include "Hit_Judgment.h"


//eNX`f[^[
TextureData E_Bullet;  //e
TextureData E_Laser;  //e


int frag;
int frag_1;
float E_count;			//G̈ړǗJEg

struct E_BULLET {
	int isLive;
	float x, y;
	float vx, vy;
	float dir;
	float angle;
	float speed;
	int state;
	int state2;
};
E_BULLET e_bullet[E_BULLET_MAX];

struct E_LASER {
	int isLive;
	float x, y;
	float distance;
	float angle;
};
E_LASER e_laser[E_LASER_MAX];

bool screenfrag;

//struct E_FIRING_PORTS {
//	float x,y;
//};
//E_FIRING_PORTS e_firing_ports[FIFNG_PORTS_MAX];

void Enemy_Bullet_Initialize_Texture() {
	LoadTexture(TEXT("assets/bullet_B.png"), &E_Bullet);//摜ǂݍŃeNX`֐ɓ
	LoadTexture(TEXT("assets/beam.png"), &E_Laser);//摜ǂݍŃeNX`֐ɓ
}

void Enemy_Bullet_Initialize()
{
	frag = 0;
	frag_1 = 0;
	E_count = 0;
	screenfrag = false;

	for (int i = 0; i < E_BULLET_MAX; i++) {
	e_bullet[i].isLive = false;
	e_bullet[i].x = 0;
	e_bullet[i].y = 0;
	e_bullet[i].vx = 0;
	e_bullet[i].vy = 0;
	e_bullet[i].dir = 0;
	e_bullet[i].angle = 0;
	e_bullet[i].speed = 0;
	e_bullet[i].state = 0;
	e_bullet[i].state2 = 0;
	}
	for (int i = 0; i < E_LASER_MAX; i++) {
		e_laser[i].x = 0;
		e_laser[i].y = 0;
		e_laser[i].distance = 0;
		e_laser[i].angle = 0;
		e_laser[i].isLive = false;
	}
}

void Normal_A(float x, float y) {
	
	//G̏oȅij
	frag++;
	if (frag == 60) {
		for (int j = 0; j <= 628; j+=6) {
			int i = 0;
			for (; i < E_BULLET_MAX; i++) {
				if (!e_bullet[i].isLive) {
					break;
				}
			}
			if (i == E_BULLET_MAX) {
				return;
			}
			e_bullet[i].isLive = true;
			e_bullet[i].x = x;
			e_bullet[i].y = y;
			e_bullet[i].angle = j * 0.01;
			e_bullet[i].speed = 5.0f;
		}
		frag = 0;
	}
}

void SUPEL_A(float x, float y) {
	//ˌWXV
	for (int j = 0; j <= 62; j++) {
		int i = 0;
		for (; i < E_BULLET_MAX; i++) {
			if (!e_bullet[i].isLive) {
				break;
			}
		}
		if (i == E_BULLET_MAX) {
			return;
		}
		e_bullet[i].isLive = true;
		e_bullet[i].x = x;
		e_bullet[i].y = y;
		e_bullet[i].angle = j * 0.1;
		e_bullet[i].speed = 2.0f;
	}
}

void Normal_B(float x, float y) {

	//G̏oȅij
	frag++;
	if (frag == 60) {
		for (int j = 0; j <= 210; j++) {
			int i = 0;
			for (; i < E_BULLET_MAX; i++) {
				if (!e_bullet[i].isLive) {
					break;
				}
			}
			if (i == E_BULLET_MAX) {
				return;
			}
			e_bullet[i].isLive = true;
			e_bullet[i].x = x;
			e_bullet[i].y = y;
			e_bullet[i].angle = j * 0.1;
			e_bullet[i].speed = 5.0f;
		}
		frag = 0;
	}
}

void SUPEL_B(float x, float y) {
	//ˌWXV
	frag++;
	if (frag == 100) {
		for (int j = 0; j <= 62; j++) {
			int i = 0;
			for (; i < E_BULLET_MAX; i++) {
				if (!e_bullet[i].isLive) {
					break;
				}
			}
			if (i == E_BULLET_MAX) {
				return;
			}
			e_bullet[i].isLive = true;
			e_bullet[i].x = x;
			e_bullet[i].y = y;
			e_bullet[i].angle = j * 0.1;
			e_bullet[i].speed = 2.0f;
			e_bullet[i].state = 1;
		}
		frag = 0;
	}
}

void Normal_C(float x, float y) {

	//G̏oȅij
	frag++;
	if (frag == 5) {
		frag_1++;
		if (frag_1 == 3) {
			float radian = getradian(x, y);
			int i = 0;
			for (; i < E_BULLET_MAX; i++) {
				if (!e_bullet[i].isLive) {
					break;
				}
			}
			if (i == E_BULLET_MAX) {
				return;
			}
			e_bullet[i].isLive = true;
			e_bullet[i].x = x;
			e_bullet[i].y = y;
			e_bullet[i].angle = radian;
			e_bullet[i].speed = 3.0f;
			frag_1 = 0;
		}
		E_count+=0.1;
		if (E_count == 1.57) {
			E_count = 0;
		}
		for (int j = 1; j <= 4; j++) {
			int i = 0;
			for (; i < E_BULLET_MAX; i++) {
				if (!e_bullet[i].isLive) {
					break;
				}
			}
			if (i == E_BULLET_MAX) {
				return;
			}
			e_bullet[i].isLive = true;
			e_bullet[i].x = x;
			e_bullet[i].y = y;
			switch (j) {
			case 1:e_bullet[i].angle = E_count; break;
			case 2:e_bullet[i].angle = E_count+1.57; break;
			case 3:e_bullet[i].angle = E_count+3.14; break;
			case 4:e_bullet[i].angle = E_count+4.81; break;
			}
			e_bullet[i].speed = 5.0f;
		}
		frag = 0;
	}
}
void SUPEL_C(float x, float y,int state) {
	e_laser[0].distance = 50;
	e_laser[1].distance = 125;
	e_laser[2].distance = 200;
	e_laser[3].distance = 275;
	e_laser[4].distance = 350;
	e_laser[5].distance = 425;
	e_laser[6].distance = 500;
	e_laser[7].distance = 575;
	if (state == 0) {
		for (int i = 0; i < E_LASER_MAX; i++) {
			e_laser[i].angle += 0.03f;
			e_laser[i].isLive = true;
			e_laser[i].x = x + sinf(e_laser[i].angle) * e_laser[i].distance;
			e_laser[i].y = y - cosf(e_laser[i].angle) * e_laser[i].distance;
		}
		frag++;
		if (frag == 3) {
			for (int j = 0; j < E_LASER_MAX; j++) {
				int i = 0;
				for (; i < E_BULLET_MAX; i++) {
					if (!e_bullet[i].isLive) {
						break;
					}
				}
				if (i == E_BULLET_MAX) {
					return;
				}
				e_bullet[i].isLive = true;
				e_bullet[i].x = e_laser[j].x;
				e_bullet[i].y = e_laser[j].y;
				e_bullet[i].angle = e_laser[j].angle;
				e_bullet[i].speed = 2.0f;
			}
			frag = 0;
		}
	}

	if(state == 1){
		for (int i = 0; i < E_LASER_MAX; i++) {
			e_laser[i].angle = 3.15f;
			e_laser[i].isLive = true;
			e_laser[i].x = x + sinf(e_laser[i].angle) * e_laser[i].distance;
			e_laser[i].y = y - cosf(e_laser[i].angle) * e_laser[i].distance;
		}
		frag++;
		if (frag == 3) {
			for (int j = 0; j < E_LASER_MAX; j++) {
				int i = 0;
				for (; i < E_BULLET_MAX; i++) {
					if (!e_bullet[i].isLive) {
						break;
					}
				}
				if (i == E_BULLET_MAX) {
					return;
				}
				e_bullet[i].isLive = true;
				e_bullet[i].x = e_laser[j].x;
				e_bullet[i].y = e_laser[j].y;
				e_bullet[i].angle = e_laser[j].angle;
				e_bullet[i].speed = 1.0f+(i*0.01);
			}
			frag = 0;
		}
	}
	if (state == 2) {
		for (int i = 0; i < E_LASER_MAX; i++) {
			e_laser[i].angle = 3.15f;
			e_laser[i].isLive = true;
			e_laser[i].x = x + sinf(e_laser[i].angle) * e_laser[i].distance;
			e_laser[i].y = y - cosf(e_laser[i].angle) * e_laser[i].distance;
		}
		frag++;
		if (frag == 3) {
			for (int j = 0; j < E_LASER_MAX; j++) {
				int i = 0;
				for (; i < E_BULLET_MAX; i++) {
					if (!e_bullet[i].isLive) {
						break;
					}
				}
				if (i == E_BULLET_MAX) {
					return;
				}
				e_bullet[i].isLive = true;
				e_bullet[i].x = e_laser[j].x;
				e_bullet[i].y = e_laser[j].y;
				e_bullet[i].angle = e_laser[j].angle + 3.14159f;
				e_bullet[i].speed = 1.0f+(i*0.01);
			}
			frag = 0;
		}
	}
	if (state == 3) {
		
		for (int i = 0; i < E_LASER_MAX; i++) {
			e_laser[i].angle -= 0.03f;
			e_laser[i].isLive = true;
			e_laser[i].x = x + sinf(e_laser[i].angle) * e_laser[i].distance;
			e_laser[i].y = y - cosf(e_laser[i].angle) * e_laser[i].distance;
		}
		frag++;
		if (frag == 3) {
			for (int j = 0; j < E_LASER_MAX; j++) {
				int i = 0;
				for (; i < E_BULLET_MAX; i++) {
					if (!e_bullet[i].isLive) {
						break;
					}
				}
				if (i == E_BULLET_MAX) {
					return;
				}
				e_bullet[i].isLive = true;
				e_bullet[i].x = e_laser[j].x;
				e_bullet[i].y = e_laser[j].y;
				e_bullet[i].angle = e_laser[j].angle + 3.14159f;
				e_bullet[i].speed = 2.0f;
			}
			frag = 0;
		}
	}
//	e_laser[0].angle = 3.15f;
////	e_laser[0].angle -= 0.08f;
//	e_laser[0].isLive = true;
//	e_laser[0].distance = 50;
//	e_laser[0].x = x + sinf(e_laser[0].angle) * e_laser[0].distance;
//	e_laser[0].y = y - cosf(e_laser[0].angle) * e_laser[0].distance;

//	if (e_laser[0].angle >= PI) e_laser[0].angle -= PI * 2;

	for (int i = 0; i < E_BULLET_MAX; i++) {
		if (!e_bullet[i].isLive) {
			continue;
		}
		if (e_bullet[i].angle >= PI) e_bullet[i].angle -= PI * 2;
	}

}
void SUPEL_C_STOP() {
	for (int i = 0; i < 30; i++) {
		e_laser[i].x = 0;
		e_laser[i].y = 0;
		e_laser[i].distance = 0;
		e_laser[i].angle = 0;
		e_laser[i].isLive = false;
	}
}
void SUPEL_D(float x, float y, int state) {
	frag++;
	if (frag == 8) {
		E_count += 0.1;
		if (E_count == 3.14) {
			E_count = 0;
		}
		for (int j = 1; j <= 4; j++) {
			int i = 0;
			for (; i < E_BULLET_MAX; i++) {
				if (!e_bullet[i].isLive) {
					break;
				}
			}
			if (i == E_BULLET_MAX) {
				return;
			}
			e_bullet[i].isLive = true;
			e_bullet[i].x = x;
			e_bullet[i].y = y;
			switch (j) {
			case 1:e_bullet[i].angle = E_count; break;
			case 2:e_bullet[i].angle = E_count + 1.57; break;
			case 3:e_bullet[i].angle = E_count + 3.14; break;
			case 4:e_bullet[i].angle = E_count + 4.81; break;
			}
			e_bullet[i].speed = 2.0f;
			e_bullet[i].state = 1;
			e_bullet[i].state2 = 1;
		}
		frag = 0;
	}
	for (int i = 0; i < E_BULLET_MAX; i++) {
		if (!e_bullet[i].isLive) {
			continue;
		}
		for (int j = 0; j < E_BULLET_MAX; j++) {
			if (i != j) {
				if (!e_bullet[i].isLive) {
					continue;
				}
				float xv = e_bullet[i].x - e_bullet[j].x;
				float yv = e_bullet[i].y - e_bullet[j].y;
				float dist_A = sqrtf(xv * xv + yv * yv);

				float xv2 = x - e_bullet[i].x;
				float yv2 = y - e_bullet[i].y;
				float dist_B = sqrtf(xv2 * xv2 + yv2 * yv2);
				if (e_bullet[i].state2 == 1 && e_bullet[j].state2 == 1&& dist_A <1.0f&&dist_B >2.0f) {
					e_bullet[i].state2 = 0;
					e_bullet[j].state2 = 0;
					e_bullet[i].isLive = false;
					e_bullet[j].isLive = false;
					for (int k = 0; k < 10; k++) {
						int l = 0;
						for (; l < E_BULLET_MAX; l++) {
							if (!e_bullet[l].isLive) {
								break;
							}
						}
						if (l == E_BULLET_MAX) {
							return;
						}
						e_bullet[l].isLive = true;
						e_bullet[l].x = e_bullet[i].x;
						e_bullet[l].y = e_bullet[i].y;
						e_bullet[l].angle = l + 10/ 6.28;
						e_bullet[l].speed = 2.0f;
						e_bullet[l].state2 = 0;
						e_bullet[l].state = 0;
					}
				}
			}
		}
	}
}


void Enemy_Bullet_Update() {
	//e̍WXV
	for (int i = 0; i < E_BULLET_MAX; i++) {
		if (!e_bullet[i].isLive) {
			continue;
		}
		if (e_bullet[i].state == 3) {
			e_bullet[i].x += cos(e_bullet[i].angle) *e_bullet[i].speed;      // xWXV
			e_bullet[i].y -= sin(e_bullet[i].angle) * e_bullet[i].speed;      // yWXV
			screenfrag = Out_Of_Screen_Judgment_Bullet(e_bullet[i].x, e_bullet[i].y);
			e_bullet[i].isLive = screenfrag;

		} else if (e_bullet[i].state == 2) {
			e_bullet[i].x -= cos(e_bullet[i].angle) *e_bullet[i].speed;      // xWXV
			e_bullet[i].y += sin(e_bullet[i].angle) * e_bullet[i].speed;      // yWXV
			screenfrag = Out_Of_Screen_Judgment_Bullet(e_bullet[i].x, e_bullet[i].y);
			e_bullet[i].isLive = screenfrag;

		} else if (e_bullet[i].state == 1) {
			e_bullet[i].x += cos(e_bullet[i].angle) *e_bullet[i].speed;      // xWXV
			e_bullet[i].y += sin(e_bullet[i].angle) * e_bullet[i].speed;      // yWXV
			screenfrag = Out_Of_Screen_Judgment_Bullet_hansya_X(e_bullet[i].x, e_bullet[i].y);
			if (screenfrag == true) {
				e_bullet[i].state = 2;
				e_bullet[i].speed = 3;
			} else {
				screenfrag = Out_Of_Screen_Judgment_Bullet_hansya_Y(e_bullet[i].x, e_bullet[i].y);
				if (screenfrag == true) {
					e_bullet[i].state = 3;
					e_bullet[i].speed = 3;
				} else {
					screenfrag = Out_Of_Screen_Judgment_Bullet_hansya_Y2(e_bullet[i].x, e_bullet[i].y);
					if (screenfrag == true) {
						e_bullet[i].isLive = false;
					}
				}
			}

		} else {
			e_bullet[i].x += cos(e_bullet[i].angle) *e_bullet[i].speed;      // xWXV
			e_bullet[i].y += sin(e_bullet[i].angle) * e_bullet[i].speed;      // yWXV
			//ʊOɒes
			screenfrag = Out_Of_Screen_Judgment_Bullet(e_bullet[i].x, e_bullet[i].y);
			e_bullet[i].isLive = screenfrag;
		}
			bool hitfrag = Player_Hit_Decision(e_bullet[i].x, e_bullet[i].y);
			if (hitfrag == true) {
				e_bullet[i].isLive = false;
			}
	}
	for (int i = 0; i < E_LASER_MAX; i++) {
		if (!e_laser[i].isLive) {
			continue;
		}
		bool hitfrag_laser = Player_Hit_Decision_laser(
			e_laser[i].x + sinf(e_laser[i].angle - PI * .25f) * PLAYER_TEXTURE_SIZE / 2,//x1
			e_laser[i].y - cosf(e_laser[i].angle - PI * .25f) * PLAYER_TEXTURE_SIZE / 2,//y1
			e_laser[i].x + sinf(e_laser[i].angle + PI * .25f) * PLAYER_TEXTURE_SIZE / 2,//x1
			e_laser[i].y - cosf(e_laser[i].angle + PI * .25f) * PLAYER_TEXTURE_SIZE / 2,//y1
			e_laser[i].x + sinf(e_laser[i].angle - PI * .75f) * PLAYER_TEXTURE_SIZE / 2,//x1
			e_laser[i].y - cosf(e_laser[i].angle - PI * .75f) * PLAYER_TEXTURE_SIZE / 2,//y1
			e_laser[i].x + sinf(e_laser[i].angle + PI * .75f) * PLAYER_TEXTURE_SIZE / 2,//x1
			e_laser[i].y - cosf(e_laser[i].angle + PI * .75f) * PLAYER_TEXTURE_SIZE / 2//y1
			);
	}
}

void Enemy_Bullet_Render()
{
	for (int i = 0; i < E_BULLET_MAX; i++) {
		if (!e_bullet[i].isLive) {
			continue;
		}
		DrowTexture(
			e_bullet[i].x - BULLET_TEXTURE_SIZE,//x1
			e_bullet[i].y - BULLET_TEXTURE_SIZE,//y1
			e_bullet[i].x + BULLET_TEXTURE_SIZE,//x2
			e_bullet[i].y + BULLET_TEXTURE_SIZE,//y2
			E_Bullet);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	}

	//[U[`
	for (int i = 0; i < E_LASER_MAX; i++) {
		if (!e_laser[i].isLive) {
			continue;
		}
		DrowTexture(
			e_laser[i].x + sinf(e_laser[i].angle - PI * .25f) * PLAYER_TEXTURE_SIZE,//x1
			e_laser[i].y - cosf(e_laser[i].angle - PI * .25f) * PLAYER_TEXTURE_SIZE,//y1
			e_laser[i].x + sinf(e_laser[i].angle + PI * .25f) * PLAYER_TEXTURE_SIZE,//x1
			e_laser[i].y - cosf(e_laser[i].angle + PI * .25f) * PLAYER_TEXTURE_SIZE,//y1
			e_laser[i].x + sinf(e_laser[i].angle - PI * .75f) * PLAYER_TEXTURE_SIZE,//x1
			e_laser[i].y - cosf(e_laser[i].angle - PI * .75f) * PLAYER_TEXTURE_SIZE,//y1
			e_laser[i].x + sinf(e_laser[i].angle + PI * .75f) * PLAYER_TEXTURE_SIZE,//x1
			e_laser[i].y - cosf(e_laser[i].angle + PI * .75f) * PLAYER_TEXTURE_SIZE,//y1
			E_Laser);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	}
}

void Enemy_Bullet_Open()
{
	CleanupResource(E_Bullet);
	CleanupResource(E_Laser);
}
