#include "Enemy_MoveMent.h"
#include "EnemyBullet.h"
#include "global.h"
#include "Drawing.h"


TextureData Enemy_Firing_ports;


float vx;		//G̈ړx
float vy;		//G̈ړy
int E_count_4a;			//G̈ړǗJEg
int E_count_4b;
int E_count_3a;
int E_count_3b;
int E_count_2a;
int E_count_2b;
int E_count_1;

//G̔ˌ
struct E_EFP {
	int isLive;
	float x, y;
	float vx, vy;
	float dir;
	float angle;
	float speed;
	int state;		//SUPEL_CɂčoŮǗ
};
E_EFP e_efp[ENEMY_FIRING_PORTS];

void Enemy_MoveMent_Initialize_Texture() {
	LoadTexture(TEXT("assets/mahouzin.png"), &Enemy_Firing_ports);
}

void Enemy_MoveMent_Initialize() {
	vx = 0;
	vy = 0;
	E_count_4a = 0;
	E_count_4b = 0;
	E_count_3a = -1;
	E_count_3b = -1;
	E_count_2a = -1;
	E_count_2b = -31;
	E_count_1 = -31;
	for (int i = 0; i < ENEMY_FIRING_PORTS; i++) {
		e_efp[i].isLive = false;
		e_efp[i].x = 0;
		e_efp[i].y = 0;
		e_efp[i].vx = 0;
		e_efp[i].vy = 0;
		e_efp[i].dir = 0;
		e_efp[i].angle = 0;
		e_efp[i].speed = 0;
		e_efp[i].state = 0;
	}
}

void Enemy___4_A(float&x, float& y) {
	E_count_4a++;
	//G̈ړ
	if (E_count_4a >= 100 && E_count_4a <= 150) {
		vx += 0.035;
		vy += 0.02;
	}
	if (E_count_4a >= 300 && E_count_4a <= 350) {
		vx -= 0.02;
		vy -= 0.03;
	}
	if (E_count_4a >= 500 && E_count_4a <= 550) {
		vx -= 0.04;
		vy += 0.02;
	}
	if (E_count_4a >= 700 && E_count_4a <= 750) {
		vx += 0.03;
		vy += 0.017;
	}
	if (E_count_4a >= 800) E_count_4a = 0;
	if (vx >= 0) vx -= 0.01; else vx += 0.01;
	if (vy >= 0) vy -= 0.01; else vy += 0.01;
	x += vx;
	y += vy;
	//U
	Normal_A(x, y);
}

void Enemy___4_B(float&x, float& y) {
	//ړ
	if (E_count_4b == 0) {
		if (x != ENEMY_STATE_POSITION_X) {
			vx = (ENEMY_STATE_POSITION_X - x) / 30;
		}
		if (y != ENEMY_STATE_POSITION_Y) {
			vy = (ENEMY_STATE_POSITION_Y - y) / 30;
		}
		Enemy_Bullet_Initialize();
		e_efp[0].isLive = true;
		e_efp[0].x = x + sinf(0) * 150.f;
		e_efp[0].y = y - cosf(0) * 150.f;
		e_efp[1].isLive = true;
		e_efp[1].x = x + sinf(0) * 150.f;
		e_efp[1].y = y - cosf(0) * 150.f;
	}
	E_count_4b++;
	//ړ
	if (E_count_4b < 30) {
		x += vx;
		y += vy;
	}
	//UJn
	if (E_count_4b >= 30) {
		if (E_count_4b == 120) {
			SUPEL_A(e_efp[0].x, e_efp[0].y);
			SUPEL_A(e_efp[1].x, e_efp[1].y);
			E_count_4b = 30;
		}
#if 0
		if (e_efp[0].state == 0) {
			e_efp[0].y -= 1;
			if (e_efp[0].y < 30) {
				e_efp[0].state = 1;
			}

		}
		if (e_efp[0].state == 1) {
			e_efp[0].y += 1;
			if (e_efp[0].y > 600) {
				e_efp[0].state = 0;
			}

		}
#else

		static float	rot;
		e_efp[0].x = x + sinf(rot) * 150.f;
		e_efp[0].y = y - cosf(rot) * 150.f;
		rot += .01;
		if (rot >= PI) rot -= PI * 2;

#endif
#if 0
		if (e_efp[1].state == 0) {
			e_efp[1].y -= 1;
			if (e_efp[1].y < 30) {
				e_efp[1].state = 1;
			}

		}
		if (e_efp[1].state == 1) {
			e_efp[1].y += 1;
			if (e_efp[1].y > 600) {
				e_efp[1].state = 0;
			}
		}
	}
#else

		static float	rotb;
		e_efp[1].x = x + sinf(rotb) * 150.f;
		e_efp[1].y = y - cosf(rotb) * 150.f;
		rotb -= .01;
		if (rotb >= PI) rotb -= PI * 2;

#endif
	}
}

void Enemy___3_A(float&x, float& y) {
	//
	if (E_count_3a == -1) {
		Enemy_Bullet_Initialize();
		Enemy_MoveMent_Initialize();
	}
	E_count_3a++;
	//G̈ړ
	if (E_count_3a >= 100 && E_count_3a <= 150) {
		vx += 0.035;
		vy += 0.02;
	}
	if (E_count_3a >= 300 && E_count_3a <= 350) {
		vx -= 0.02;
		vy -= 0.03;
	}
	if (E_count_3a >= 500 && E_count_3a <= 550) {
		vx -= 0.04;
		vy += 0.02;
	}
	if (E_count_3a >= 700 && E_count_3a <= 750) {
		vx += 0.03;
		vy += 0.017;
	}
	if (E_count_3a >= 800) E_count_3a = 0;
	if (vx >= 0) vx -= 0.01; else vx += 0.01;
	if (vy >= 0) vy -= 0.01; else vy += 0.01;
	x += vx;
	y += vy;
	//U
	Normal_B(x, y);
}


void Enemy___3_B(float&x, float& y) {
	//
	if (E_count_3b == -1) {
		Enemy_Bullet_Initialize();
		Enemy_MoveMent_Initialize();
		if (x != ENEMY_STATE_POSITION_X) {
			vx = (ENEMY_STATE_POSITION_X - x) / 30;
		}
		if (y != ENEMY_STATE_POSITION_Y) {
			vy = (ENEMY_STATE_POSITION_Y - y) / 30;
		}
	}
	E_count_3b++;

	//ړ
	if (E_count_3b < 30) {
		x += vx;
		y += vy;
	}
	if (E_count_3b == 29) {
		vx = 0;
		vy = 0;
	}

	//G̈ړ
	if (E_count_3b >= 130 && E_count_3b <= 180) {
		vx += 0.035;
		vy += 0.02;
	}
	if (E_count_3b >= 330 && E_count_3b <= 380) {
		vx -= 0.02;
		vy -= 0.03;
	}
	if (E_count_3b >= 530 && E_count_3b <= 580) {
		vx -= 0.04;
		vy += 0.02;
	}
	if (E_count_3b >= 730 && E_count_3b <= 780) {
		vx += 0.03;
		vy += 0.017;
	}
	if (E_count_3b >= 830) E_count_3b = 30;
	if (E_count_3b >= 30) {
		if (vx >= 0) vx -= 0.01; else vx += 0.01;
		if (vy >= 0) vy -= 0.01; else vy += 0.01;
		x += vx;
		y += vy;
	}
	//U
	SUPEL_B(x, y);
}

void Enemy___2_A(float&x, float& y) {
	//
	if (E_count_2a == -1) {
		Enemy_Bullet_Initialize();
		Enemy_MoveMent_Initialize();
		if (x != ENEMY_STATE_POSITION_X) {
			vx = (ENEMY_STATE_POSITION_X - x) / 30;
		}
		if (y != ENEMY_STATE_POSITION_Y) {
			vy = (ENEMY_STATE_POSITION_Y - y) / 30;
		}
	}
	E_count_2a++;

	//ړ
	if (E_count_2a < 30) {
		x += vx;
		y += vy;
	}
	if (E_count_2a == 29) {
		vx = 0;
		vy = 0;
	}

	//G̈ړ
	if (E_count_2a >= 130 && E_count_2a <= 180) {
		vx += 0.035;
		vy += 0.02;
	}
	if (E_count_2a >= 330 && E_count_2a <= 380) {
		vx -= 0.02;
		vy -= 0.03;
	}
	if (E_count_2a >= 530 && E_count_2a <= 580) {
		vx -= 0.04;
		vy += 0.02;
	}
	if (E_count_2a >= 730 && E_count_2a <= 780) {
		vx += 0.03;
		vy += 0.017;
	}
	if (E_count_2a >= 830) E_count_2a = 30;
	if (E_count_2a >= 30) {
		if (vx >= 0) vx -= 0.01; else vx += 0.01;
		if (vy >= 0) vy -= 0.01; else vy += 0.01;
		x += vx;
		y += vy;
		Normal_C(x, y);
	}
	//U
}

void Enemy___2_B(float&x, float& y) {

	//
	if (E_count_2b == -31) {
		Enemy_Bullet_Initialize();
		Enemy_MoveMent_Initialize();
		if (x != ENEMY_STATE_POSITION_X) {
			vx = (ENEMY_STATE_POSITION_X - x) / 30;
		}
		if (y != ENEMY_STATE_POSITION_Y) {
			vy = (ENEMY_STATE_POSITION_Y - y) / 30;
		}
	}

	E_count_2b++;
	if (E_count_2b < -1) {
		x += vx;
		y += vy;
	}

	//U
	if (E_count_2b >= 30 && E_count_2b < 150) {
		e_efp[0].state = 0;
		SUPEL_C(x, y, e_efp[0].state);
	}
	//ړW
	if (E_count_2b == 150) {
		vx = (30 - x) / 30;
		vy = (80 - y) / 30;
		SUPEL_C_STOP();
	}
	//ړ
	if (E_count_2b >= 150&& E_count_2b < 180) {
		x += vx;
		y += vy;
	}
	//ړW
	if (E_count_2b == 210) {
		vx = (470 - x) / 89;
		vy = (90 - y) / 90;
	}
	//ړ&U
	if (E_count_2b >= 210 && E_count_2b < 300) {
		e_efp[0].state = 2;
		x += vx;
		y += vy;
		vx += 0.01f;
		SUPEL_C(x, y, e_efp[0].state);
	}
	//ړW
	if (E_count_2b == 300) {
		vx = (560 - x) / 30;
		vy = (70 - y) / 30;
		SUPEL_C_STOP();
	}
	//ړ
	if (E_count_2b >= 300 && E_count_2b < 320) {
		x += vx;
		y += vy;
	}
	//ړW
	if (E_count_2b == 370) {
		vx = (130 - x) / 89;
		vy = (100 - y) / 90;
	}
	//ړ&U
	if (E_count_2b >= 370 && E_count_2b < 460) {
		e_efp[0].state = 1;
		x += vx;
		y += vy;
		vx -= 0.01f;
		SUPEL_C(x, y, e_efp[0].state);
	}
	//ړW
	if (E_count_2b == 460) {
		vx = (ENEMY_STATE_POSITION_X - x) / 120;
		vy = (ENEMY_STATE_POSITION_Y - y) / 120;
		SUPEL_C_STOP();
	}
	//ړ&U
	if (E_count_2b >= 460 && E_count_2b < 580) {
		e_efp[0].state = 3;
		x += vx;
		y += vy;
		SUPEL_C(x, y, e_efp[0].state);
	}
	//UXgbv
	if (E_count_2b == 580) {
		SUPEL_C_STOP();
	}
	//xŏ
	if (E_count_2b == 610) {
		E_count_2b = 0;
	}
}

void Enemy___1(float&x, float& y) {
	//
	if (E_count_1 == -31) {
		Enemy_Bullet_Initialize();
		Enemy_MoveMent_Initialize();
		if (x != ENEMY_STATE_POSITION_X) {
			vx = (ENEMY_STATE_POSITION_X - x) / 30;
		}
		if (y != ENEMY_STATE_POSITION_Y) {
			vy = (ENEMY_STATE_POSITION_Y - y) / 30;
		}
	}

	E_count_1++;
	if (E_count_1 < -1) {
		x += vx;
		y += vy;
	}

	if (E_count_1 >= 0) {
		SUPEL_D(x, y,0);
	}
}


void Enemy_MoveMent_Render() {
	for (int i = 0; i < ENEMY_FIRING_PORTS; i++) {
		if (e_efp[i].isLive == true) {
			DrowTexture(
				e_efp[i].x - 64,//x1
				e_efp[i].y - 64,//y1
				e_efp[i].x + 64,//x2
				e_efp[i].y + 64,//y2
				Enemy_Firing_ports);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
		}
	}
}

void Enemy_MoveMent_Open() {
	CleanupResource(Enemy_Firing_ports);
}