#include "Player.h"
#include "Drawing.h"
#include "DirectX.h"
#include "PlayerBullet.h"
#include "global.h"
#include "Hit_Judgment.h"
#include "UI.h"
#include "Key_Check.h"
#include "EnemyBullet.h"


// eNX`[̉
TextureData Player; //vC[
TextureData Player_Firing_ports_A; //vC[̒e̔ˌ
TextureData Player_Hit_UI;	//vC[̓蔻̉摜

int Count;			//S̖GԂ̃JEg

struct PLAYER{
	float x,y;
	int isLive;
	int state;
//	int life;
	int zanki;
	bool SPLfrag;
};
PLAYER player;

struct PFp {
	float x1, x2,x3, y1, y2,y3;
};
PFp pfp;

void Playr_Initialize_Texture() {
	LoadTexture(TEXT("assets/Player_AOI.png"), &Player);//摜ǂݍŃeNX`֐ɓ
	LoadTexture(TEXT("assets/bullet_A.png"), &Player_Firing_ports_A);
	LoadTexture(TEXT("assets/C_Bullet_C.png"), &Player_Hit_UI);
}

//
void Player_Initialize()
{
	Count == 0;
	player.x = PLAYER_STATE_POSITION_X;
	player.y = PLAYER_STATE_POSITION_Y;
	player.isLive = true;
	player.zanki = PLAYER_ZANKI;
	player.state = 0;
	pfp.x1 = player.x + 10;
	pfp.y1 = player.y - 55;
	pfp.x2 = player.x - 10;
	pfp.y2 = player.y - 55;
	pfp.x3 = player.x;
	pfp.y3 = player.y - 60;
	player.SPLfrag = false;
}

//XV
void Player_Update()
{
	if (player.isLive == true) {
		//vC[ړ(Shift ON or OFFňړXs[h؂ւj
		if (key_on&KEYIN_LEFT) {
			if (key_on&KEYIN_SFT) {
				player.x -= 1.5f;

			}
			else {
				player.x -= 4.5f;
			}
		}
		if (key_on&KEYIN_RIGHT) {
			if (key_on&KEYIN_SFT) {
				player.x += 1.5f;
			}
			else {
				player.x += 4.5f;
			}
		}
		if (key_on&KEYIN_UP) {
			if (key_on&KEYIN_SFT) {
				player.y -= 1.5f;
			}
			else {
				player.y -= 4.5f;
			}
		}
		if (key_on&KEYIN_DOWN) {
			if (key_on&KEYIN_SFT) {
				player.y += 1.5f;
			}
			else {
				player.y += 4.5f;
			}
		}
		//ʊOɏoȂ悤ɂ
		int Screenfrag_x = Out_Of_Screen_Judgment_X(player.x);
		if (Screenfrag_x != false) {
			player.x = Screenfrag_x;
		}
		int Screenfrag_y = Out_Of_Screen_Judgment_Y(player.y);
		if (Screenfrag_y != false) {
			player.y = Screenfrag_y;
		}

		//ˌ̍WXV(Shift ON or OFFŐ؂ւ)
		if (key_on&KEYIN_SFT) {
			pfp.x1 = player.x + 10;
			pfp.y1 = player.y - 55;
			pfp.x2 = player.x - 10;
			pfp.y2 = player.y - 55;
			pfp.x3 = player.x;
			pfp.y3 = player.y - 60;
		}
		else {
			pfp.x1 = player.x + 30;
			pfp.y1 = player.y;
			pfp.x2 = player.x - 30;
			pfp.y2 = player.y;
			pfp.x3 = player.x;
			pfp.y3 = player.y - 50;
		}
		//e
		if (key_on&KEYIN_Z) {
			Player_Bullet_Call(pfp.x1, pfp.y1, pfp.x2, pfp.y2, pfp.x3, pfp.y3);
		}
		//XƂ̏
		if (key_on&KEYIN_X) {
			player.SPLfrag = true;
		}
		else {
			player.SPLfrag = false;
		}
	}
	if (player.isLive == false) {
		if(Count ==0)		player.zanki--; Player_zanki(player.zanki,0);
		if (player.zanki == 0) {
			Game_State = GAME_END;
		} else {
			Count++;
			if (Count == 18) {

			}
			if (Count == 20) {
				player.x = PLAYER_STATE_POSITION_X;
				player.y = PLAYER_STATE_POSITION_Y;
				Player_Bullet_Initialize();
				Enemy_Bullet_Initialize();
				player.isLive = true;
				Count = 0;
			}	
		}
	}
}

//`揈
void Player_Render()
{
	if (player.isLive == true) {
		DrowTexture(
			player.x - PLAYER_TEXTURE_SIZE,//x1
			player.y - PLAYER_TEXTURE_SIZE,//y1
			player.x + PLAYER_TEXTURE_SIZE,//x2
			player.y + PLAYER_TEXTURE_SIZE,//y2
			Player);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
#if 0
		static float r;
		DrowTexture(
			player.x + sinf(r-PI*.25f) * PLAYER_TEXTURE_SIZE,//x1
			player.y - cosf(r-PI*.25f) * PLAYER_TEXTURE_SIZE,//y1
			player.x + sinf(r+PI*.25f) * PLAYER_TEXTURE_SIZE,//x1
			player.y - cosf(r+PI*.25f) * PLAYER_TEXTURE_SIZE,//y1
			player.x + sinf(r-PI*.75f) * PLAYER_TEXTURE_SIZE,//x1
			player.y - cosf(r-PI*.75f) * PLAYER_TEXTURE_SIZE,//y1
			player.x + sinf(r+PI*.75f) * PLAYER_TEXTURE_SIZE,//x1
			player.y - cosf(r+PI*.75f) * PLAYER_TEXTURE_SIZE,//y1
			Player);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
		r += .01f;
#endif
		DrowTexture(
			pfp.x1 - PLAYER_FIRING_PORTS,//x1
			pfp.y1 - PLAYER_FIRING_PORTS,//y1
			pfp.x1 + PLAYER_FIRING_PORTS,//x2
			pfp.y1 + PLAYER_FIRING_PORTS,//y2
			Player_Firing_ports_A);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
		DrowTexture(
			pfp.x2 - PLAYER_FIRING_PORTS,//x1
			pfp.y2 - PLAYER_FIRING_PORTS,//y1
			pfp.x2 + PLAYER_FIRING_PORTS,//x2
			pfp.y2 + PLAYER_FIRING_PORTS,//y2
			Player_Firing_ports_A);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
		DrowTexture(
			pfp.x3 - PLAYER_FIRING_PORTS,//x1
			pfp.y3 - PLAYER_FIRING_PORTS,//y1
			pfp.x3 + PLAYER_FIRING_PORTS,//x2
			pfp.y3 + PLAYER_FIRING_PORTS,//y2
			Player_Firing_ports_A);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
		DrowTexture(
			player.x - PLAYER_HIT_DISTANCE,//x1
			player.y - PLAYER_HIT_DISTANCE,//y1
			player.x + PLAYER_HIT_DISTANCE,//x2
			player.y + PLAYER_HIT_DISTANCE,//y2
			Player_Hit_UI);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	}
}

//J
void Player_Open()
{
	CleanupResource(Player);
	CleanupResource(Player_Firing_ports_A);
	CleanupResource(Player_Hit_UI);
}

//G̒eƂ̓蔻
bool Player_Hit_Decision(float x, float y) {
	float xv = player.x - x;
	float yv_A = player.y - y;
	float dist_A = sqrtf(xv * xv + yv_A * yv_A);
	if (player.isLive == true && player.SPLfrag == false) {
		if (dist_A < 6.0f) {
			//player.life--;
			player.isLive = false;
			return true;
		}
	}
	return false;
}

///[U[̓蔻
//[U[̒[_Ƃ̐ڐG
bool laser_1(float x0, float y0, float x1, float y1, float x2, float y2, float x3, float y3) {
	float vx[4] = {player.x - x0,player.x - x1,player.x - x2,player.x - x3 };
	float vy[4] = {player.y - y0,player.y - y1,player.y - y2,player.y - y3 };
	for (int i = 0; i < 4; i++) {
		float dist = sqrtf(vx[i]*vx[i] + vy[i]*vy[i]);
		if (dist < 6.0f) {
			player.isLive = false;
			return true;
		}
	}
	return false;
}

//xNg[Iɍ쐬
float CreateVector(float p0,float p1) {
	return p1 - p0;
}

//xNg̓
float InnerProduct(float x0,float y0,float x1,float y1) {
	return (x0*x1 + y0*y1);
}

//xNg̒2
float VectorLength2(float x, float y) {
	return InnerProduct(x,y,x,y);
}

//[U[̊eӂƉ~̐ڐG
bool laser_2(float x0, float y0, float x1, float y1, float x2, float y2, float x3, float y3) {
	float px[4] = { x0, x1, x2, x3 };
	float py[4] = { y0, y1, y2, y3 };
	float pqx, pqy, pmx, pmy;
	float inner, k,pqd2, pmd2, phd2, d2;

	const int n[][4] = {{0,1,3,2},{1,3,2,0}};
	for (int i = 0; i < 4; i++) {
		pqx = CreateVector(px[n[0][i]], px[n[1][i]]);
		pqy = CreateVector(py[n[0][i]], py[n[1][i]]);
		pmx = CreateVector(px[n[0][i]], player.x);
		pmy = CreateVector(py[n[0][i]], player.y);

		inner = InnerProduct(pqx, pqy, pmx, pmy);
		pqd2 = VectorLength2(pqx, pqy);
		pmd2 = VectorLength2(pmx, pmy);

		k = inner / pqd2;
		if (k < 0 || 1 < k)continue;
		phd2 = inner * k;

		d2 = pmd2 - phd2;

		if (d2 < 6.0f*6.0f) {
			player.isLive = false;
			return true;
		}
	}
	return false;
}

//xNg̊O
bool OuterProduct(float x0, float y0, float x1, float y1) {
	return (x0*y1 - y0 * x1);
}

//[U[ɓ荞łȂ̔
bool laser_3(float x0, float y0, float x1, float y1, float x2, float y2, float x3, float y3) {
	float px[4] = { x0, x1, x2, x3 };
	float py[4] = { y0, y1, y2, y3 };
	float ppx, ppy, pmx, pmy;
	float inner, outer, theta[2];

	for (int i = 0; i < 2; i++) {
		ppx = CreateVector(px[i*3],px[1+i]);
		ppy = CreateVector(py[i*3],py[1+i]);
		pmx = CreateVector(px[i*3],player.x);
		pmy = CreateVector(py[i*3],player.y);

		inner = InnerProduct(ppx,ppy,pmx,pmy);
		outer = OuterProduct(ppx,ppy,pmx,pmy);

		theta[i] = RTOD(atan2(outer, inner));
	}

	if (0 <= theta[0] && theta[0] <= 90 &&
		0 <= theta[1] && theta[1] <= 90) {
		player.isLive = false;
		return true;
	}

	return false;
}

//[U[Ɖ~Ƃ̓蔻
bool Player_Hit_Decision_laser(float x0,float y0,float x1,float y1,float x2,float y2,float x3,float y3) {
	if (player.isLive == true&& player.SPLfrag == false) {
		laser_1(x0,y0,x1,y1,x2,y2,x3,y3);
		laser_2(x0, y0, x1, y1, x2, y2, x3, y3);
		laser_3(x0, y0, x1, y1, x2, y2, x3, y3);
	}
	return false;
}

//G̔ˊpx߂邽߂̊֐ivC[Ɍđłj
float getradian(float x, float y) {
	float radian = atan2(player.y - y, player.x - x);
	return radian;
}