#include "UI.h"
#include "Drawing.h"
#include "DirectX.h"
#include "global.h"

#define PLAYER_ZANKI 4				//vC[̂̎c@


TextureData background;
TextureData zanki;
TextureData enemy_cutin;

struct CUTIN {
	float life;						//JbgCo
	float Start_x, Start_y;			//Jnʒu
	float x, y;
	float End_x, End_y;				//Iʒu
	float Startlifetime;
};
CUTIN cutin;

int UI_zanki;				//vC[̎c@UI.cppŎgp邽߂̊֐
int UI_SPL_remaining;

void UI_Initialize_Texture() {
	LoadTexture(TEXT("assets/HAIKEI.png"), &background);//摜ǂݍŃeNX`֐ɓ
	LoadTexture(TEXT("assets/ZANKI_UI.png"), &zanki);//摜ǂݍŃeNX`֐ɓ
	LoadTexture(TEXT("assets/Enemy_AKANE_CutIn.png"), &enemy_cutin);//摜ǂݍŃeNX`֐ɓ
}

void UI_Initialize()
{
	
	UI_zanki = PLAYER_ZANKI;
	UI_SPL_remaining = PLAYER_SPEL;
	cutin.life = 0;
	cutin.Start_x = 500;
	cutin.Start_y = 600;
	cutin.x = 500;
	cutin.y = 432;
	cutin.End_x = 500;
	cutin.End_y = 0;
	cutin.Startlifetime = -2.5f;
}

void UI_Update()
{
	float deltaTime = 1.0f / 60;
	cutin.life += deltaTime;
	if (cutin.life < 0) {
	float liferate = cutin.life / cutin.Startlifetime;
	cutin.x =
		(cutin.End_x -cutin.Start_x)*liferate + cutin.Start_x;
	cutin.y =
		(cutin.End_y - cutin.Start_y)*liferate + cutin.Start_y;
	}
}

void UI_Render()
{
	if (cutin.life < 0) {
		DrowTexture(cutin.x - 768, cutin.y - 768, cutin.x + 768, cutin.y + 768, enemy_cutin);
	}
	DrowTexture(0,0,960,720,background);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	switch (UI_zanki) {
		case 4:DrowTexture(664+64+10, 60, 664+64+64+10, 60 + 64, zanki);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
		case 3:DrowTexture(664+10, 60, 664 + 64+10, 60 + 64, zanki);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
		case 2:DrowTexture(600, 60, 600 + 64, 60 + 64, zanki); break;//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	}
	switch (UI_SPL_remaining) {
	case 4:DrowTexture(664 + 64 + 10, 140, 664 + 64 + 64 + 10, 140 + 64, zanki);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	case 3:DrowTexture(664 + 10, 140, 664 + 64 + 10, 140 + 64, zanki);//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
//	case 2:
	case 1:DrowTexture(600, 140, 600 + 64, 140 + 64, zanki); break;//ix1,y1,x2,y2,ǂݍ񂾃eNX`֐)w肵ĕ`悷
	}

}

void UI_Open()
{
	CleanupResource(background);
	CleanupResource(zanki);
	CleanupResource(enemy_cutin);
}

void Player_zanki(int zanki ,int SPLremaining) {
	UI_zanki = zanki;
	UI_SPL_remaining =  SPLremaining;
}

void Cut_In() {
	cutin.life = -1.f;
}
