#include "stdafx.h"
#include "Window.h"
#include "DirectX.h"
#include "fbxsdk.h"
#include "VertexIndex.h"
#include "Drawing.h"
#include "GameState.h"
#include "global.h"
#include "Debug.h"
#include "ogg.h"


// Gg[|Cg
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | _CRTDBG_ALLOC_MEM_DF);	//CRTDBGL K[h
	int width = 960;
	int height = 720;
	if (!CreateSimpleWindow(TEXT("l"), 0, 0, width, height))
	{
		return false;
	}

	//TEh
	if (InitSound(0) != 0) {
		return 1;
	}



	InitializeDirectX(GetWindowHandle(), width, height, false);
	Game_Initialize_Texture();
	Game_Initialize();
	// C[v
	while (!IsQuitMessage())
	{
		Game_Update();
		Game_Render();
		UpdateWindowMessage();
	}
	Game_Open();
	EndSound();
	FinalizeDirectX();

#if 0
	Vertex();
#endif
	return 0;
}
